.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/delete.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/delete.cmdsrc,v 1.8 1993/01/26 02:43:13 aoki Exp
.TH DELETE COMMANDS 01/23/93
.XA 2 Delete
.SH NAME
delete \(em delete instances from a class
.SH SYNOPSIS
.(l M
\fBdelete\fR instance_variable [ \fBfrom\fR from_list ] [ \fBwhere\fR qual ]
.)l
.SH DESCRIPTION
.BR Delete
removes instances which satisfy the qualification,
.IR qual ,
from the class specified by
.IR instance_variable .
.IR Instance_variable
is either a class name or a variable assigned by
.IR from_list .
If the qualification is absent, the effect is to delete all instances
in the class.  The result is a valid, but empty class.
.PP
You must have write access to the class in order to modify it, as well
as read access to any class whose values are read in the qualification
(see
.IR "change acl" (commands).
.SH EXAMPLE
.(C
/*
 * Remove all employees who make over $30,000
 */
delete emp where emp.sal > 30000
.)C
.(C
/*
 * Clear the hobbies class
 */
delete hobbies
.)C
.SH "SEE ALSO"
destroy(commands).
