.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/remove_rule.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/remove_rule.cmdsrc,v 1.6 1993/01/26 02:43:13 aoki Exp
.TH "REMOVE RULE" COMMANDS 01/23/93
.XA 2 "Remove Rule"
.SH NAME
remove rule \- removes a current rule from \*(PG 
.SH SYNOPSIS
.(l M
\fBremove\fR [ \fBinstance\fR | \fBrewrite\fR ] \fBrule\fR rule_name
.)l
.SH DESCRIPTION
This command drops the rule named rule_name from the specified \*(PG
rule system.  \*(PG will immediately cease enforcing it and will purge
its definition from the system catalogs.
.SH EXAMPLE
.(C
/*
 * This example drops the rewrite rule example_1
 */
remove rewrite rule example_1
.)C
.SH "SEE ALSO"
define rule(commands),
remove view(commands).
.SH BUGS
Once a rule is dropped, access to historical information the rule has
written may disappear.
