.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/vacuum.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/vacuum.cmdsrc,v 1.4 1993/01/26 02:43:13 aoki Exp
.TH VACUUM COMMANDS 01/23/93
.XA 2 Vacuum
.SH NAME
vacuum \(em vacuum a database
.SH SYNOPSIS
.(l M
\fBvacuum\fP
.)l
.SH DESCRIPTION
.BR Vacuum
is the \*(PG vacuum cleaner.  It opens every class in the database,
moves deleted records to the archive for archived relations, cleans
out records from aborted transactions, and updates statistics in the
system catalogs.  The statistics maintained include the number of
tuples and number of pages stored in all classes.  Running
.BR vacuum
periodically will increase \*(PG's speed in processing user queries.
.PP
The open database is the one that is vacuumed.  This is a new \*(PQ
command in Version \*(PV; earlier versions of \*(PG had a separate
program for vacuuming databases.  That program has been replaced by
the
.IR vacuum (unix)
shell script.
.PP
We recommend that production databases be vacuumed nightly, in order
to keep statistics relatively current.  The
.BR vacuum
query may be executed at any time, however.  In particular, after
copying a large class into \*(PG or deleting a large number of
records, it may be a good idea to issue a
.BR vacuum
query.  This will update the system catalogs with the results of all
recent changes, and allow the \*(PG query optimizer to make better
choices in planning user queries.
.SH "SEE ALSO"
vacuum(unix).
